import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Iterator;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;

/**
 * This class open an XLS file and update some values. 
 * 
 * These values are used in the xls file to display a chart. A
 * macro was needed in order to force the chart to refresh.
 * 
 * THIS TEST WORKS WITH POI 2.0-final BUT NOT WITH 2.5-final 
 * (error when loading in m$excel 2002 10.5815.4219)
 * 
 * @author Frdric Dreier
 * 
 * 
 * anyway, thanks to the POI developers team and contributors for
 * the work already done :-)
 * 
 * Regards
 * 
 */
public class PoiTempl {
    private static final String FILENAME = "testoutput.xls";
    private static final String TEMPLATE = "graph_template.xls";

    public PoiTempl(File output) throws Exception {

        POIFSFileSystem fs = new POIFSFileSystem(new FileInputStream(TEMPLATE));

        HSSFWorkbook wb = new HSSFWorkbook(fs);
        HSSFSheet sheet = wb.getSheetAt(0);
        
        // update chart's values
        HSSFRow row = sheet.getRow(21); 
        for (short x=2; x<15; x++) {
            HSSFCell cell = row.getCell(x);            
            int value = (int)((Math.random()+1) * 200000);
            cell.setCellValue(value);         
            sheet.setColumnWidth(x,(short)128);
        }
        row = sheet.getRow(22); 
        for (short x=2; x<15; x++) {
            HSSFCell cell = row.getCell(x);            
            int value = (int)(Math.random()* 10000);
            cell.setCellValue(value);         
            sheet.setColumnWidth(x,(short)255);
        }


        // create a new file
        
        FileOutputStream out = new FileOutputStream(output);

        wb.write(out);
        out.close();
        
    }

    public static void main(String[] args) throws Exception {

        
        
        //BasicConfigurator.configure();
        //System.setProperty("org.apache.poi.util.POILogger","org.apache.poi.util.CommonsLogger");

        System.out.println("poy poy...");
        File tmp = File.createTempFile("testxls_",FILENAME);
        tmp.deleteOnExit();
        
        new PoiTempl(tmp);

        try {
         Process p = Runtime.getRuntime().exec( "C:\\Program Files\\Microsoft Office\\Office10\\EXCEL.EXE " + tmp.getAbsolutePath()); 
         p.waitFor();
        } catch (Exception e) {
            System.out.println("could not find excel.");
        }
        System.out.println("done.");

    }
}